#ifndef TURNOUT_H
#define TURNOUT_H

#define NO_STEPPER
#define NO_SERVO
#define NO_L293D
#define NO_L298N
#define NO_RELAY
#define NO_BUTTONSCOMMANDERENCODER
#define NO_BUTTONSCOMMANDERSWITCH
#define NO_BUTTONSCOMMANDERPOTENTIOMETER
#define NO_SERIALCOMMANDER

#define KDCC_INTERRUPT 0
#define FIRST_PIN  3
#define FIRST_DCC  40

#include <UniversalAccessoryDecoder.h>

class TurnOut {

public :

TurnOut();

void SetupDccDigital_Inverted (int TurnOutNb, int DccID, int activation, int intensity = 255, int ledPin = 53, int pinButton = 69);
void SetupDccDigital (int TurnOutNb, int DccID, int activation, int intensity = 255, int ledPin = 53, int pinButton = 69);
void LoopDcc();

void SetupDigital_Inverted (int TurnOutNb,int activation, int intensity = 255);
void SetupDigital (int TurnOutNb,int activation, int intensity = 255);
void Loop();

private :

    void SetupDCC (int TurnOutNb, int DccID, int activation, int intensity, int ledPin, int pinButton, PORT_TYPE porttype);
    void Setup (int TurnOutNb,int activation, int intensity,PORT_TYPE porttype,bool mode);
    DccCommander dcc;
    ButtonsCommander button;
    DriverArduino *arduino;
    Accessories turnOuts;
    AccessoryGroup light;

};
#endif

