//-------------------------------------------------------------------
#ifndef __accessories_H__
#define __accessories_H__
//-------------------------------------------------------------------

#include "Accessory.hpp"

//-------------------------------------------------------------------

//-------------------------------------------------------------------

// Describes static data only intialized once at the beginning of execution.

class Accessories;

class StaticAccessoriesData
{
public:
	// List of pointers	to all accessories lists declared.
	// The commanders can enumerate this list to find thing to move...
	Accessories* *pAccessoriesFullList;
	int AccessoriesSize;
	int AccessoriesAddCounter;

	StaticAccessoriesData();
};

class Accessories
{
	public:
		static StaticAccessoriesData AccessoriesFullList;

	private:
		unsigned char size;
		unsigned char addCounter;
		Accessory* *pList;
		
	protected:
	
	public:
		Accessories();
		
		Accessory *GetById(int inDccId, byte inDccIdAccessory) const;
		int GetSize() const { return this->size; }
		void Setup(int num);
		void Setup(int num, Accessory *pFirstAccessory, ...);
		static void AddAccessoriesList(Accessories *inAccessories);
		void Set(unsigned char inIndex, Accessory *inpAccessory);
		unsigned char Add(Accessory *inpAccessory);
		void AddRange(const Accessories &inAccessories);
		Accessory *operator[](unsigned char idx);

		bool Loop();

		bool CanMove(int inDccId, byte inDccIdAccessory);

		void ButtonToggle(int inIndex);
		bool DCCToggle(int DccId, byte inDccIdAccessory);
		bool MovePosition(int DccId, byte inDccIdAccessory, int inPosition);
		bool IsActionPending();

	public:
#ifdef DEBUG_MODE
		void CheckIndex(unsigned char inIndex, const __FlashStringHelper *infunc);
#endif
};


//-------------------------------------------------------------------

//===================================================================
// -> DO NOT WRITE ANYTHING BETWEEN HERE...
// 		This section is reserved for automated code generation
// 		This process tries to detect all user-created
// 		functions in main_sketch.cpp, and inject their  
// 		declarations into this file.
// 		If you do not want to use this automated process,  
//		simply delete the lines below, with "&MM_DECLA" text 
//===================================================================
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_BEG@---------------------
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_END@---------------------
// -> ...AND HERE. This space is reserved for automated code generation!
//===================================================================


//-------------------------------------------------------------------
#endif
//-------------------------------------------------------------------
