//-------------------------------------------------------------------
#ifndef __buttonsCommander_H__
#define __buttonsCommander_H__
//-------------------------------------------------------------------

#ifndef NO_BUTTONSCOMMANDER
#include "UniversalAccessoryDecoder.h"

//-------------------------------------------------------------------

//-------------------------------------------------------------------

class ButtonsCommander : Commander
{
	private:
		unsigned char size;
		unsigned char addCounter;
		ButtonsCommanderButton* *pButtons;
		int selectedDccIdDecoder;
		byte selectedDccIdAccessory;
		ButtonsCommanderButton *pLastSelectedButton;

	public:
		ButtonsCommander();

		void Setup(int inSize);
		void Setup(int inSize, ButtonsCommanderButton *inpFirstState, ...);
		void Set(unsigned char inIndex, ButtonsCommanderButton *inpState);
		unsigned char Add(ButtonsCommanderButton *inpButton);
		inline ButtonsCommanderButton *operator[](unsigned char idx) { return this->pButtons[idx]; }
		int IndexOf(ButtonsCommanderButton *inpbutton);
		inline ButtonsCommanderButton *GetLastSelectedButton() const { return this->pLastSelectedButton; }

	public:
		bool Loop();

public:
#ifdef DEBUG_MODE
	void CheckIndex(unsigned char inIndex, const __FlashStringHelper *infunc);
#endif
};

//-------------------------------------------------------------------

//===================================================================
// -> DO NOT WRITE ANYTHING BETWEEN HERE...
// 		This section is reserved for automated code generation
// 		This process tries to detect all user-created
// 		functions in main_sketch.cpp, and inject their  
// 		declarations into this file.
// 		If you do not want to use this automated process,  
//		simply delete the lines below, with "&MM_DECLA" text 
//===================================================================
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_BEG@---------------------
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_END@---------------------
// -> ...AND HERE. This space is reserved for automated code generation!
//===================================================================


//-------------------------------------------------------------------
#endif
#endif
//-------------------------------------------------------------------
