//-------------------------------------------------------------------
#ifndef __buttonsCommanderButton_H__
#define __buttonsCommanderButton_H__
//-------------------------------------------------------------------

#include "Arduino.h"

//-------------------------------------------------------------------
// A button is a hardware device allowing user to activate an accessory or a group.
// when this device is used, a DCC id is sent, and the according accessory
// can do the job.
//-------------------------------------------------------------------

class ButtonsCommanderButton
{
 private:
	 int DccIdDecoder;
	 byte DccIdAccessory;

 public:
	 inline ButtonsCommanderButton(int inDccIdDecoder, byte inDccIdAccessory) { this->DccIdDecoder = inDccIdDecoder; this->DccIdAccessory = inDccIdAccessory; }
	 inline virtual int GetDccIdDecoder() const { return this->DccIdDecoder; }
	 inline virtual byte GetDccIdAccessory() const { return this->DccIdAccessory; }
	 inline virtual bool IsAnalog() const { return false; }
	 inline virtual int GetPosition() const { return 0; }

	 inline virtual bool Loop() { return false; }
	 inline virtual void EndLoop() {}
};

//-------------------------------------------------------------------

//===================================================================
// -> DO NOT WRITE ANYTHING BETWEEN HERE...
// 		This section is reserved for automated code generation
// 		This process tries to detect all user-created
// 		functions in main_sketch.cpp, and inject their  
// 		declarations into this file.
// 		If you do not want to use this automated process,  
//		simply delete the lines below, with "&MM_DECLA" text 
//===================================================================
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_BEG@---------------------
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_END@---------------------
// -> ...AND HERE. This space is reserved for automated code generation!
//===================================================================


//-------------------------------------------------------------------
#endif
//-------------------------------------------------------------------
