//-------------------------------------------------------------------
#ifndef __buttonsCommanderSwitch_H__
#define __buttonsCommanderSwitch_H__
//-------------------------------------------------------------------

#ifdef UAD_VC
#include "VStudio/arduino2.hpp"
#else
#include "arduino2.hpp"
#endif
#include "ButtonsCommanderButton.hpp"

//-------------------------------------------------------------------

//-------------------------------------------------------------------

#define SWITCH(list, nb)	((ButtonsCommanderSwitch *) list[nb])

struct DccIdPin
{
	int Decoder;
	byte Accessory;
	GPIO_pin_t Pin;

	int buttonState;       // the current reading from the input pin
	int lastButtonState;   // the previous reading from the input pin
	unsigned long lastDebounceTime;  // the last time the output pin was toggled
};

class ButtonsCommanderSwitch : public ButtonsCommanderButton
{
 private:
	unsigned long debounceDelay;    // the debounce time; increase if the output flickers
	
	int dccIdSize;
	int dccIdAddCounter;
	int dccIdLoopCounter;
	DccIdPin *pDccId;
	int dccIdState;

public:
	ButtonsCommanderSwitch(int inDccIdNumber);
	
	void Setup();
	void AddDccId(int inDccIdDecoder, byte inDccIdAccessory, int inPin);
	bool Loop();
	int GetDccIdDecoder() const;
	byte GetDccIdAccessory() const;
};

//-------------------------------------------------------------------

//===================================================================
// -> DO NOT WRITE ANYTHING BETWEEN HERE...
// 		This section is reserved for automated code generation
// 		This process tries to detect all user-created
// 		functions in main_sketch.cpp, and inject their  
// 		declarations into this file.
// 		If you do not want to use this automated process,  
//		simply delete the lines below, with "&MM_DECLA" text 
//===================================================================
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_BEG@---------------------
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_END@---------------------
// -> ...AND HERE. This space is reserved for automated code generation!
//===================================================================


//-------------------------------------------------------------------
#endif
//-------------------------------------------------------------------
