//-------------------------------------------------------------------
#ifndef __driverPortArduino_H__
#define __driverPortArduino_H__
//-------------------------------------------------------------------

#include "DriverPort.hpp"

//-------------------------------------------------------------------

//-------------------------------------------------------------------

#ifndef NO_ARDUINODRIVER
class DriverPortArduino : public DriverPort
{
	protected:
		GPIO_pin_t pin;
		PORT_TYPE portType;
		int GetAnalogValue(int inValue) const;

	public:
		DriverPortArduino();
		
		virtual void Setup(int inPin, PORT_TYPE inType = DIGITAL);
		
		inline bool IsActive() const { return this->pin != (GPIO_pin_t) DP_INVALID; }
		inline int GetPin() const { return GPIO_to_Arduino_pin(this->pin); }
		inline GPIO_pin_t GetPin2() const { return this->pin; }
		
		inline PORT_TYPE GetPortType() const { return this->portType; }

		int SetSpeed(int inSpeed);

		void MoveLeftDir(unsigned long inDuration = 0);
		void MoveRightDir(unsigned long inDuration = 0);
		void MoveStop();
};
#endif

//-------------------------------------------------------------------

//===================================================================
// -> DO NOT WRITE ANYTHING BETWEEN HERE...
// 		This section is reserved for automated code generation
// 		This process tries to detect all user-created
// 		functions in main_sketch.cpp, and inject their  
// 		declarations into this file.
// 		If you do not want to use this automated process,  
//		simply delete the lines below, with "&MM_DECLA" text 
//===================================================================
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_BEG@---------------------
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_END@---------------------
// -> ...AND HERE. This space is reserved for automated code generation!
//===================================================================


//-------------------------------------------------------------------
#endif
//-------------------------------------------------------------------
