//-------------------------------------------------------------------
#ifndef __driverPortServoArduino_H__
#define __driverPortServoArduino_H__
//-------------------------------------------------------------------

#ifndef NO_SERVO
#if defined UAD_VC
class Servo
{
public:
	Servo() {}

	void attach(int) {}
	void write(int) {}
	int read() { return 0; }
	bool attached() { return false; }

	int servoIndex;
};
#else
#include "Servo.hpp"
#endif
#endif

#include "UniversalAccessoryDecoder.h"

//-------------------------------------------------------------------

//-------------------------------------------------------------------

#ifndef NO_SERVO
class DriverPortServoArduino : public DriverPortServo
{
	protected:      
		int pin;    
		Servo servo;

	public:
		DriverPortServoArduino();
		
		void Setup(int inPin, PORT_TYPE inType);
		void SetupByAccessory(int inStartingPosition);

		inline bool IsActive() const { return this->pin > -1; }
		inline int GetPin() const { return this->pin; }
		inline GPIO_pin_t GetPin2() const { return Arduino_to_GPIO_pin(this->pin); }
		
		void MovePosition(unsigned long inDuration, int inEndPosition);
		int GetPosition();
};
#endif

//-------------------------------------------------------------------

//===================================================================
// -> DO NOT WRITE ANYTHING BETWEEN HERE...
// 		This section is reserved for automated code generation
// 		This process tries to detect all user-created
// 		functions in main_sketch.cpp, and inject their  
// 		declarations into this file.
// 		If you do not want to use this automated process,  
//		simply delete the lines below, with "&MM_DECLA" text 
//===================================================================
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_BEG@---------------------
//---- DO NOT DELETE THIS LINE -- @MM_DECLA_END@---------------------
// -> ...AND HERE. This space is reserved for automated code generation!
//===================================================================


//-------------------------------------------------------------------
#endif
//-------------------------------------------------------------------
