/*
 * decodeur pour des aiguilles à solenoide et a 2 positions sur Arduino MEGA
 * en mode DCC
 * base sur le project: <DCC Accessory Decoder> de Thierry PARIS
 * 
 * aiguille y : bobine1 pin x (IdDccy/0), bobine2 pin x+1 (IdDccy/1)
 * nombre max d'aiguille y
 * 
 * interruption int0 pour le DCC sur pin 2
 * 
 */

/********************************************************************
 * PARAMETRES DE CONFIGURATION
 * 
 *********************************************************************/
 #define NB_TURN_OUT 4      // nombre d'aiguillages
#define ACTIVATION 250    // activation de 250ms
#define ID_DCC 40         // en mode DCC, adresse DCC de depart du premier aiguillage

/**********************************************************************
 * LES PARAMETRES INTERNES
 * 
 *************************************************************************/
 
#include <UniversalAccessoryDecoder.h>  // la biliotheque UAD
#include "TurnOut.h"                    // la classe des aiguillages

TurnOut aiguilles;      // une instance des aiguillages

void setup() {
  // en mode DCC
  aiguilles.SetupDccDigital_Inverted(NB_TURN_OUT,ID_DCC,ACTIVATION);  // commande = LOW
  //aiguilles.SetupDccDigital(NB_TURN_OUT,ID_DCC,ACTIVATION);          // ou commande = HIGH

  //en mode TCO
   //aiguilles.SetupDigital_Inverted(NB_TURN_OUT,ACTIVATION);  // commande = LOW
  //aiguilles.SetupDccDigital(NB_TURN_OUT,ACTIVATION);       // ou commande = HIGH
  
  }

/*
 * la boucle se limite a une methode
 */
void loop() {
  // en mode DCC
  aiguilles.LoopDcc();
  // en mode TCO
  //aiguilles.Loop();
  }



